// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from novatel_gps_msgs:msg/NovatelXYZ.idl
// generated code does not contain a copyright notice
#include "novatel_gps_msgs/msg/detail/novatel_xyz__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `novatel_msg_header`
#include "novatel_gps_msgs/msg/detail/novatel_message_header__functions.h"
// Member `solution_status`
// Member `position_type`
// Member `velocity_solution_status`
// Member `velocity_type`
// Member `base_station_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `extended_solution_status`
#include "novatel_gps_msgs/msg/detail/novatel_extended_solution_status__functions.h"
// Member `signal_mask`
#include "novatel_gps_msgs/msg/detail/novatel_signal_mask__functions.h"

bool
novatel_gps_msgs__msg__NovatelXYZ__init(novatel_gps_msgs__msg__NovatelXYZ * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // novatel_msg_header
  if (!novatel_gps_msgs__msg__NovatelMessageHeader__init(&msg->novatel_msg_header)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // solution_status
  if (!rosidl_runtime_c__String__init(&msg->solution_status)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // position_type
  if (!rosidl_runtime_c__String__init(&msg->position_type)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // x
  // y
  // z
  // x_sigma
  // y_sigma
  // z_sigma
  // velocity_solution_status
  if (!rosidl_runtime_c__String__init(&msg->velocity_solution_status)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // velocity_type
  if (!rosidl_runtime_c__String__init(&msg->velocity_type)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // x_vel
  // y_vel
  // z_vel
  // x_vel_sigma
  // y_vel_sigma
  // z_vel_sigma
  // base_station_id
  if (!rosidl_runtime_c__String__init(&msg->base_station_id)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // velocity_latency
  // diff_age
  // solution_age
  // num_satellites_tracked
  // num_satellites_used_in_solution
  // num_gps_and_glonass_l1_used_in_solution
  // num_gps_and_glonass_l1_and_l2_used_in_solution
  // extended_solution_status
  if (!novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__init(&msg->extended_solution_status)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  // signal_mask
  if (!novatel_gps_msgs__msg__NovatelSignalMask__init(&msg->signal_mask)) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
    return false;
  }
  return true;
}

void
novatel_gps_msgs__msg__NovatelXYZ__fini(novatel_gps_msgs__msg__NovatelXYZ * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // novatel_msg_header
  novatel_gps_msgs__msg__NovatelMessageHeader__fini(&msg->novatel_msg_header);
  // solution_status
  rosidl_runtime_c__String__fini(&msg->solution_status);
  // position_type
  rosidl_runtime_c__String__fini(&msg->position_type);
  // x
  // y
  // z
  // x_sigma
  // y_sigma
  // z_sigma
  // velocity_solution_status
  rosidl_runtime_c__String__fini(&msg->velocity_solution_status);
  // velocity_type
  rosidl_runtime_c__String__fini(&msg->velocity_type);
  // x_vel
  // y_vel
  // z_vel
  // x_vel_sigma
  // y_vel_sigma
  // z_vel_sigma
  // base_station_id
  rosidl_runtime_c__String__fini(&msg->base_station_id);
  // velocity_latency
  // diff_age
  // solution_age
  // num_satellites_tracked
  // num_satellites_used_in_solution
  // num_gps_and_glonass_l1_used_in_solution
  // num_gps_and_glonass_l1_and_l2_used_in_solution
  // extended_solution_status
  novatel_gps_msgs__msg__NovatelExtendedSolutionStatus__fini(&msg->extended_solution_status);
  // signal_mask
  novatel_gps_msgs__msg__NovatelSignalMask__fini(&msg->signal_mask);
}

novatel_gps_msgs__msg__NovatelXYZ *
novatel_gps_msgs__msg__NovatelXYZ__create()
{
  novatel_gps_msgs__msg__NovatelXYZ * msg = (novatel_gps_msgs__msg__NovatelXYZ *)malloc(sizeof(novatel_gps_msgs__msg__NovatelXYZ));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(novatel_gps_msgs__msg__NovatelXYZ));
  bool success = novatel_gps_msgs__msg__NovatelXYZ__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
novatel_gps_msgs__msg__NovatelXYZ__destroy(novatel_gps_msgs__msg__NovatelXYZ * msg)
{
  if (msg) {
    novatel_gps_msgs__msg__NovatelXYZ__fini(msg);
  }
  free(msg);
}


bool
novatel_gps_msgs__msg__NovatelXYZ__Sequence__init(novatel_gps_msgs__msg__NovatelXYZ__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  novatel_gps_msgs__msg__NovatelXYZ * data = NULL;
  if (size) {
    data = (novatel_gps_msgs__msg__NovatelXYZ *)calloc(size, sizeof(novatel_gps_msgs__msg__NovatelXYZ));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = novatel_gps_msgs__msg__NovatelXYZ__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        novatel_gps_msgs__msg__NovatelXYZ__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
novatel_gps_msgs__msg__NovatelXYZ__Sequence__fini(novatel_gps_msgs__msg__NovatelXYZ__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      novatel_gps_msgs__msg__NovatelXYZ__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

novatel_gps_msgs__msg__NovatelXYZ__Sequence *
novatel_gps_msgs__msg__NovatelXYZ__Sequence__create(size_t size)
{
  novatel_gps_msgs__msg__NovatelXYZ__Sequence * array = (novatel_gps_msgs__msg__NovatelXYZ__Sequence *)malloc(sizeof(novatel_gps_msgs__msg__NovatelXYZ__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = novatel_gps_msgs__msg__NovatelXYZ__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
novatel_gps_msgs__msg__NovatelXYZ__Sequence__destroy(novatel_gps_msgs__msg__NovatelXYZ__Sequence * array)
{
  if (array) {
    novatel_gps_msgs__msg__NovatelXYZ__Sequence__fini(array);
  }
  free(array);
}
